
////////////////////////////////////////////////////////////////////////////
//                   PaneMultiTab by Elm (www.netcult.ch/elmue)
////////////////////////////////////////////////////////////////////////////

#pragma once

class CPaneMultiTab : public CXTPMDIFrameWnd
{
public:
	// This class stores only the document list, the rest of the funcionality it not used.
	// This class is required because CMultiDocTemplate::RemoveDocument()
	// is called automatically when a Document gets closed so this list is maintained up to date automagically.
	class CDocumentList : public CMultiDocTemplate
	{
	public:
		CDocumentList() : CMultiDocTemplate(1, NULL, NULL, NULL)
		{
		}
		~CDocumentList()
		{
			// if there are Documents left you did not call CPaneMultiTab::CloseAll()
			ASSERT(GetCount() == 0);
		}
		virtual void LoadTemplate()
		{
			// do nothing here (overwrite template loading stuff)
		}
		int GetCount()
		{
			return m_docList.GetCount();
		}
	};

	// --------------------------------------------------------------------------

	CPaneMultiTab();
	virtual ~CPaneMultiTab();
	
	CDocument* AddNewTab(LPCTSTR s_Path, UINT u32_ResourceID, CRuntimeClass* pi_DocClass, CRuntimeClass* pi_ViewClass, CRuntimeClass* pi_FrameClass, BOOL b_MakeVisible=TRUE);
	void       RemoveDoc(CDocument* pi_Doc);
	POSITION   GetFirstDocPosition() const;
	CDocument* GetNextDoc(POSITION& Pos) const;
	int        GetDocCount();
	CDocument* GetDocByPath(CString s_Path);
	BOOL       ActivateFile(CString s_Path);
	BOOL       ActivateDoc (CDocument* pi_Doc);
	BOOL       SaveAndClose(CDocument* pi_Doc);
	BOOL       SaveAll();
	BOOL       CloseAll();
	CView*     GetActiveView();
	CDocument* GetActiveDoc();

protected:
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPaneMultiTab)
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* p_Conetxt);
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CPaneMultiTab)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	CDocumentList     mi_DocList;
	CXTPTabClientWnd  mi_TabbedWorkspace;
};

//{{AFX_INSERT_LOCATION}}
